<?php
defined('BASEPATH') OR exit('No direct script access allowed');

/*
| -------------------------------------------------------------------------
| URI ROUTING
| -------------------------------------------------------------------------
| This file lets you re-map URI requests to specific controller functions.
|
| Typically there is a one-to-one relationship between a URL string
| and its corresponding controller class/method. The segments in a
| URL normally follow this pattern:
|
| example.com/class/method/id/
|
| In some instances, however, you may want to remap this relationship
| so that a different class/function is called than the one
| corresponding to the URL.
|
| Please see the user guide for complete details:
|
| https://codeigniter.com/user_guide/general/routing.html
|
| -------------------------------------------------------------------------
| RESERVED ROUTES
| -------------------------------------------------------------------------
|
| There are three reserved routes:
|
| $route['default_controller'] = 'welcome';
|
| This route indicates which controller class should be loaded if the
| URI contains no data. In the above example, the "welcome" class
| would be loaded.
|
| $route['404_override'] = 'errors/page_missing';
|
| This route will tell the Router which controller/method to use if those
| provided in the URL cannot be matched to a valid route.
|
| $route['translate_uri_dashes'] = FALSE;
|
| This is not exactly a route, but allows you to automatically route
| controller and method names that contain dashes. '-' isn't a valid
| class or method name character, so it requires translation.
| When you set this option to TRUE, it will replace ALL dashes in the
| controller and method URI segments.
|
| Examples: my-controller/index -> my_controller/index
|   my-controller/my-method -> my_controller/my_method
*/
$route['default_controller'] = 'adminpanel';
$route['404_override'] = '';
$route['translate_uri_dashes'] = TRUE;

/*
| -------------------------------------------------------------------------
|  API Routes
| -------------------------------------------------------------------------
*/
$route['api/get-products/(:num)'] = 'api/get_products/id/$1';
$route['api/get-questions/(:num)'] = 'api/get_questions/id/$1';
$route['api/facebook-register/(:num)'] = 'api/facebook_register/id/$1';
$route['api/facebook-login/(:num)'] = 'api/facebook_login/id/$1';
$route['api/google-login/(:num)'] = 'api/google_login/id/$1';
$route['api/google-register/(:num)'] = 'api/google_register/id/$1';
$route['api/add-notes/(:num)'] = 'api/add_notes/id/$1';
$route['api/add-questionnotes/(:num)'] = 'api/add_questionnotes/id/$1';
$route['api/forgot-password/(:num)'] = 'api/forgot_password/id/$1';
$route['api/reset-password/(:num)'] = 'api/reset_password/id/$1';
$route['api/set-user-result/(:num)'] = 'api/set_user_result/id/$1';
$route['api/get-statistics/(:num)'] = 'api/get_statistics/id/$1';
$route['api/get-question-notes/(:num)'] = 'api/get_question_notes/id/$1';
$route['api/get-questionwise-notes/(:num)'] = 'api/get_questionwise_notes/id/$1';
$route['api/get-counts/(:num)'] = 'api/get_counts/id/$1';


