<?php
defined('BASEPATH') or exit('No direct script access allowed');

class Adminpanel extends CI_Controller
{

    public function __construct()
    {
        parent::__construct();
    }

    public function index()
    {
        if (!$this->session->userdata('is_log_in')) {
            redirect('adminpanel/login');
        } else {
            redirect('adminpanel/dashboard');
        }
    }

    public function login()
    {
        $this->form_validation->set_rules('email', 'Email', 'required');
        $this->form_validation->set_rules('password', 'Password', 'required');

        if (isset($_POST['admin-login-submit'])) {
            if ($this->form_validation->run() == true) {
                $this->user_model->validateAdminLogin($this->input->post(null, true));
            } else {
                $this->data['page_title'] = "AdminSAGE | Log in";
                $this->data['error_message'] = validation_errors();
                $this->load->view('admin/login', $this->data);
            }
        } else {
            $this->data['page_title'] = "AdminSAGE | Log in";
            $this->data['error_message'] = validation_errors() ? validation_errors() : $this->session->flashdata('error_message');
            $this->load->view('admin/login', $this->data);
        }
    }

    public function dashboard()
    {
        $this->data['page_title'] = "Dashboard";
        $this->load->view('admin/dashboard', $this->data);

    }

    public function products()
    {
        $this->data['page_title'] = "Products";
        $products = $this->products_model->getProducts();
        if ($products['status']) {
            $this->data['products'] = $products['products'];
        } else {
            $this->data['products'] = array();
        }
        $this->load->view('admin/products', $this->data);

    }

    public function customnotification()
    {
        $this->data['page_title'] = "Custom Notification";
        $this->load->view('admin/customnotification', $this->data);
        if (isset($_REQUEST["addcatg"])) {
            $this->load->library('form_validation');
            $this->form_validation->set_rules('title', 'Name', 'trim|required');
            $this->form_validation->set_rules('description', 'Description', 'trim|required');
            $data["error"] = "";
            if ($this->form_validation->run() == false) {
                if ($this->form_validation->error_string() != "") {
                    $data["error"] = '<div class="alert alert-error alert-dismissible" role="alert">
                                        <i class="fa fa-warning"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Warning!</strong> ' . $this->form_validation->error_string() . '
                                    </div>';
                }
            } else {
                $addcat = array(
                    "title" => $this->input->post("title"),
                    "description" => $this->input->post("description"),
                    "url" => $this->input->post("url"),
                );
                
                if ($_FILES["cat_img"]["size"] > 0) {
                    $config['upload_path'] = './uploads/';
                    $config['allowed_types'] = 'gif|jpg|png|jpeg';
                    $config['encrypt_name'] = true;
                    $this->load->library('upload', $config);

                    if ($this->upload->do_upload('cat_img')) {
                        $img_data = $this->upload->data();

                        $addcat["image"] = $img_data['file_name'];
                    } else {
                        $data["error"] = '<div class="alert alert-error alert-dismissible" role="alert">
                                        <i class="fa fa-warning"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Warning!</strong> ' . $this->upload->display_errors() . '
                                    </div>';

                    }

                }
                if ($data["error"] == "") {
                    $content = array(
                        "en" => $addcat['description'],
                    );
                    $imageURL = "";
                    if (!empty($addcat['image'])) {
                        $imageURL = base_url() . 'uploads/' . $addcat['image'];
                    }

                    $fields = array(
                        'app_id' => '00bc4af6-0def-4e35-aa5a-57eeed5df04f',
                        'included_segments' => array('All'),
                        'data' => array("foo" => "bar"),
                        'headings' => array("en" => $addcat['title']),
                        'contents' => $content,
                        'big_picture' => $imageURL,
                        'ios_badgeType'=>'Increase',
                        'ios_badgeCount'=> 1
                    );

                    $this->load->helper('gcm_helper');
                    $gcm = new GCM();
                    $gcm->onesignal_send($fields);

                    $this->session->set_flashdata("success_req", '<div class="alert alert-success alert-dismissible" role="alert">
                                    <i class="fa fa-check"></i>
                                    <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                    <strong>Success!</strong> Your Custom Notification is sent....
                                </div>');
                    redirect('adminpanel/customnotification');
                    exit;
                }
            }
        }
    }

    public function deleteproduct($id)
    {
        if ($this->products_model->delete_product($id)) {
            $this->session->set_flashdata("success_req", '<div class="alert alert-success alert-dismissible" role="alert">
                                        <i class="fa fa-check"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Success!</strong> Product deleted successfully...
                                    </div>');
            redirect('adminpanel/products');
        } else {
            $this->session->set_flashdata("success_req", '<div class="alert alert-danger alert-dismissible" role="alert">
                                        <i class="fa fa-check"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Failed!</strong> Product cannot be deleted...
                                    </div>');
            redirect('adminpanel/products');
        }

    }

    public function addproduct()
    {
        if ($this->session->is_log_in) {

            $data["error"] = "";
            $data["active"] = "addcat";
            $data['page_title'] = "Add Product";
            if (isset($_REQUEST["addcatg"])) {
                $this->load->library('form_validation');
                $this->form_validation->set_rules('name', 'Product Name', 'trim|required');
                $this->form_validation->set_rules('price', 'Product Price', 'trim|required|numeric');
                $this->form_validation->set_rules('status', 'Product Status', 'required');
                $this->form_validation->set_rules('description', 'Product Description', 'trim|required');

                if ($this->form_validation->run() == false) {
                    if ($this->form_validation->error_string() != "") {
                        $data["error"] = '<div class="alert alert-error alert-dismissible" role="alert">
                                        <i class="fa fa-warning"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Warning!</strong> ' . $this->form_validation->error_string() . '
                                    </div>';
                    }
                } else {
                    $addcat = array(
                        "name" => $this->input->post("name"),
                        "description" => $this->input->post("description"),
                        "status" => $this->input->post("status"),
                        "price" => $this->input->post("price"),
                        "url" => $this->input->post("url"),
                    );

                    if ($_FILES["cat_img"]["size"] > 0) {
                        $config['upload_path'] = './uploads/';
                        $config['allowed_types'] = 'gif|jpg|png|jpeg';
                        $config['encrypt_name'] = true;
                        $this->load->library('upload', $config);

                        if ($this->upload->do_upload('cat_img')) {
                            $img_data = $this->upload->data();

                            $addcat["image"] = $img_data['file_name'];
                        } else {
                            $data["error"] = '<div class="alert alert-error alert-dismissible" role="alert">
                                        <i class="fa fa-warning"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Warning!</strong> ' . $this->upload->display_errors() . '
                                    </div>';

                        }

                    }
                    if ($data['error'] == '') {
                        if ($this->products_model->add_product($addcat)) {
                            /*   $registatoin_ids = array();

                            //send push notification
                            $message["title"] = "New Notification from Sage's Reloading Supply";
                            $message["text"] = "New Product - ".$addcat['name']." at an exciting price had just been added";
                            $message["image"] = base_url().'static/sage.PNG';;
                            $message["created_at"] = date("Y-m-d h:i:s");
                            $message["obj"] = "";

                            $this->load->helper('gcm_helper');
                            $gcm = new GCM();
                            //$result = $gcm->send_topics("/topics/rabbitapp",$message ,"ios");

                            // $result = $gcm->send_topics("/topics/grocery",$message ,"android");

                            //android
                            $qa = $this->db->query("Select user_gcm_code from users");
                            $registers = $qa->result();
                            foreach($registers as $regs){
                            if($regs->user_gcm_code!="")
                            $registatoin_ids[] = $regs->user_gcm_code;
                            }
                            if(count($registatoin_ids) > 1000){

                            $chunk_array = array_chunk($registatoin_ids,1000);
                            foreach($chunk_array as $chunk){
                            $result = $gcm->send_notification($chunk, $message,"android");
                            }

                            }else{
                            if(is_array($registatoin_ids) && count($registatoin_ids) > 0)
                            $result = $gcm->send_notification($registatoin_ids, $message,"android");
                            }
                            //ios
                            $q = $this->db->query("Select user_ios_token from users");
                            $registers = $q->result();
                            foreach($registers as $regs){
                            if($regs->user_ios_token!="")
                            $registatoin_ids[] = $regs->user_ios_token;
                            }
                            if(count($registatoin_ids) > 1000){

                            $chunk_array = array_chunk($registatoin_ids,1000);
                            foreach($chunk_array as $chunk){
                            $result = $gcm->send_notification($chunk, $message,"ios");
                            }

                            }else{
                            if(is_array($registatoin_ids) && count($registatoin_ids) > 0)
                            $result = $gcm->send_notification($registatoin_ids, $message,"ios");
                            }*/
                            $content = array(
                                "en" => $addcat['description'],
                                //  "en" => "New Product - ".$addcat['name']." at an exciting price had just been added"
                            );

                            $fields = array(
                                'app_id' => '00bc4af6-0def-4e35-aa5a-57eeed5df04f',
                                'included_segments' => array('All'),
                                'data' => array("foo" => "bar"),
                                'headings' => array("en" => $addcat['name']),
                                //   'headings'=> array("en" => "New Notification from Sage's Reloading Supply" ),
                                'contents' => $content,
                                'big_picture' => base_url() . 'uploads/' . $addcat['image'],
                                'ios_badgeType'=>'Increase',
                                'ios_badgeCount'=> 1
                            );

                            $this->load->helper('gcm_helper');
                            $gcm = new GCM();
                            $gcm->onesignal_send($fields);

                            $this->session->set_flashdata("success_req", '<div class="alert alert-success alert-dismissible" role="alert">
                                        <i class="fa fa-check"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Success!</strong> Product added successfully...
                                    </div>');
                            redirect('adminpanel/products');
                        } else {
                            $this->session->set_flashdata("error_req", '<div class="alert alert-danger alert-dismissible" role="alert">
                                        <i class="fa fa-check"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Failed!</strong> Failed to add products..
                                    </div>');
                            redirect('adminpanel/products');
                        }
                    }
                }
            }
            $this->load->view('admin/addproduct', $data);
        } else {
            redirect('adminpanel');
        }
    }

    public function editproduct($id)
    {
        if ($this->session->is_log_in) {

            $data["error"] = "";
            $data["product"] = $this->products_model->getProducts($id)['products'][0];
            $data['page_title'] = "Edit Categories";

            if (isset($_REQUEST["savecat"])) {
                $this->load->library('form_validation');
                $this->form_validation->set_rules('name', 'Product Name', 'trim|required');
                $this->form_validation->set_rules('price', 'Product Price', 'trim|required|numeric');
                $this->form_validation->set_rules('status', 'Product Status', 'required');
                $this->form_validation->set_rules('description', 'Product Description', 'trim|required');

                if ($this->form_validation->run() == false) {
                    if ($this->form_validation->error_string() != "") {
                        $data["error"] = '<div class="alert alert-error alert-dismissible" role="alert">
                                        <i class="fa fa-warning"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Warning!</strong> ' . $this->form_validation->error_string() . '
                                    </div>';
                    }
                } else {
                    $editcat = array(
                        "name" => $this->input->post("name"),
                        "description" => $this->input->post("description"),
                        "status" => $this->input->post("status"),
                        "price" => $this->input->post("price"),
                        "url" => $this->input->post("url"),
                    );

                    if ($_FILES["cat_img"]["size"] > 0) {
                        $config['upload_path'] = './uploads/';
                        $config['allowed_types'] = 'gif|jpg|png|jpeg';
                        $config['encrypt_name'] = true;
                        $this->load->library('upload', $config);

                        if ($this->upload->do_upload('cat_img')) {
                            $img_data = $this->upload->data();

                            $editcat["image"] = $img_data['file_name'];
                        } else {
                            $data["error"] = '<div class="alert alert-error alert-dismissible" role="alert">
                                        <i class="fa fa-warning"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Warning!</strong> ' . $this->upload->display_errors() . '
                                    </div>';

                        }

                    }
                    if ($data['error'] == '') {
                        if ($this->products_model->edit_product($id, $editcat)) {
                            if ($editcat['status'] == 1) {

                                //send push notification
                                $content = array(
                                    "en" => $editcat['description'],
                                    //  "en" => "Product - ".$editcat['name']." with a new exciting price had just been updated"
                                );

                                $field_image = isset($editcat['image']) ? base_url() . 'uploads/' . $editcat['image'] : $this->input->post('post_image');

                                $fields = array(
                                    'app_id' => '00bc4af6-0def-4e35-aa5a-57eeed5df04f',
                                    'included_segments' => array('All'),
                                    'data' => array("foo" => "bar"),
                                    'headings' => array("en" => $editcat['name']),
                                    //   'headings'=> array("en" => "New Notification from Sage's Reloading Supply" ),
                                    'contents' => $content,
                                    'big_picture' => $field_image,
                                    'ios_badgeType'=>'Increase',
                                    'ios_badgeCount'=> 1
                                );

                                $this->load->helper('gcm_helper');
                                $gcm = new GCM();
                                $gcm->onesignal_send($fields);

                                /*  $registatoin_ids = array();

                            $message["title"] = "New Notification from Sage's Reloading Supply";
                            $message["text"] = "Product - ".$editcat['name']." with a new exciting price had just been updated";
                            $message["image"] = base_url().'static/sage.PNG';
                            $message["created_at"] = date("Y-m-d h:i:s");
                            $message["obj"] = "";

                            $this->load->helper('gcm_helper');
                            $this->load->helper('gcm_helper');
                            $gcm = new GCM();
                            //$result = $gcm->send_topics("/topics/rabbitapp",$message ,"ios");

                            // $result = $gcm->send_topics("/topics/grocery",$message ,"android");
                            //android
                            $qa = $this->db->query("Select user_gcm_code from users");
                            $registers = $qa->result();
                            foreach($registers as $regs){
                            if($regs->user_gcm_code!="")
                            $registatoin_ids[] = $regs->user_gcm_code;
                            }
                            if(count($registatoin_ids) > 1000){

                            $chunk_array = array_chunk($registatoin_ids,1000);
                            foreach($chunk_array as $chunk){
                            $result = $gcm->send_notification($chunk, $message,"android");
                            }

                            }else{
                            if(is_array($registatoin_ids) && count($registatoin_ids) > 0)
                            $result = $gcm->send_notification($registatoin_ids, $message,"android");
                            }
                            //ios
                            $q = $this->db->query("Select user_ios_token from users");
                            $registers = $q->result();
                            foreach($registers as $regs){
                            if($regs->user_ios_token!="")
                            $registatoin_ids[] = $regs->user_ios_token;
                            }
                            if(count($registatoin_ids) > 1000){

                            $chunk_array = array_chunk($registatoin_ids,1000);
                            foreach($chunk_array as $chunk){
                            $result = $gcm->send_notification($chunk, $message,"ios");
                            }

                            }else{
                            if(is_array($registatoin_ids) && count($registatoin_ids) > 0)
                            $result = $gcm->send_notification($registatoin_ids, $message,"ios");
                            }*/
                            }

                            $this->session->set_flashdata("success_req", '<div class="alert alert-success alert-dismissible" role="alert">
                                        <i class="fa fa-check"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Success!</strong> Product Updated successfully...
                                    </div>');
                            redirect('adminpanel/products');
                        } else {
                            $this->session->set_flashdata("error_req", '<div class="alert alert-danger alert-dismissible" role="alert">
                                        <i class="fa fa-check"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Failed!</strong> Failed to update product..
                                    </div>');
                            redirect('adminpanel/products');
                        }
                    }
                }
            }
            $this->load->view('admin/editproduct', $data);
        } else {
            redirect('adminpanel');
        }
    }

    public function addquestion()
    {
        if ($this->session->is_log_in) {
            $data["error"] = "";
            $data["active"] = "addcat";
            $data["catlist"] = $this->category_model->getCategories()['categories'];
            $data['page_title'] = "Add Question";
            if (isset($_REQUEST["addcatg"])) {
                $this->load->library('form_validation');
                $this->form_validation->set_rules('question', 'Question', 'trim|required');
                $this->form_validation->set_rules('answer', 'Answer', 'trim|required');

                if ($this->form_validation->run() == false) {
                    if ($this->form_validation->error_string() != "") {
                        $data["error"] = '<div class="alert alert-error alert-dismissible" role="alert">
                                        <i class="fa fa-warning"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Warning!</strong> ' . $this->form_validation->error_string() . '
                                    </div>';
                    }
                } else {
                    $this->question_model->add_question();
                    $this->session->set_flashdata("success_req", '<div class="alert alert-success alert-dismissible" role="alert">
                                        <i class="fa fa-check"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Success!</strong> Question added successfully...
                                    </div>');
                    redirect('adminpanel/questions');
                }
            }
            $this->load->view('admin/addquestion', $data);
        } else {
            redirect('adminpanel');
        }
    }

    public function editquestion($id)
    {
        if ($this->session->is_log_in) {
            $data["error"] = "";
            $data["active"] = "addcat";
            $data["catlist"] = $this->category_model->getCategories()['categories'];
            $data["question"] = $this->question_model->getQuestions('', '', $id)['questions'][0];
            $data['page_title'] = "Edit question";
            if (isset($_REQUEST["addcatg"])) {
                $this->load->library('form_validation');
                $this->form_validation->set_rules('question', 'Question', 'trim|required');
                $this->form_validation->set_rules('answer', 'Answer', 'trim|required');

                if ($this->form_validation->run() == false) {
                    if ($this->form_validation->error_string() != "") {
                        $data["error"] = '<div class="alert alert-error alert-dismissible" role="alert">
                                        <i class="fa fa-warning"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Warning!</strong> ' . $this->form_validation->error_string() . '
                                    </div>';
                    }
                } else {
                    $this->question_model->edit_question($id);
                    $this->session->set_flashdata("success_req", '<div class="alert alert-success alert-dismissible" role="alert">
                                        <i class="fa fa-check"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Success!</strong> Question Updated successfully...
                                    </div>');
                    redirect('adminpanel/questions');
                }
            }
            $this->load->view('admin/editquestion', $data);
        } else {
            redirect('adminpanel');
        }
    }

    public function deletequestion($id)
    {
        if ($this->question_model->delete_question($id)) {
            $this->session->set_flashdata("success_req", '<div class="alert alert-success alert-dismissible" role="alert">
                                        <i class="fa fa-check"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Success!</strong> Question deleted successfully...
                                    </div>');
            redirect('adminpanel/questions');
        } else {
            $this->session->set_flashdata("success_req", '<div class="alert alert-danger alert-dismissible" role="alert">
                                        <i class="fa fa-check"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Failed!</strong> Question cannot be deleted...
                                    </div>');
            redirect('adminpanel/questions');
        }

    }

    public function deletequestionreport($id)
    {
        if ($this->question_model->deletequestionreport($id)) {
            $this->session->set_flashdata("success_req", '<div class="alert alert-success alert-dismissible" role="alert">
                                        <i class="fa fa-check"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Success!</strong> Question Report deleted successfully...
                                    </div>');
            redirect('adminpanel/reports');
        } else {
            $this->session->set_flashdata("success_req", '<div class="alert alert-danger alert-dismissible" role="alert">
                                        <i class="fa fa-check"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Failed!</strong> Question Report cannot be deleted...
                                    </div>');
            redirect('adminpanel/reports');
        }

    }

    public function importquestions()
    {
        if ($this->session->is_log_in) {
            $data["error"] = "";
            $data["active"] = "addcat";
            $data['page_title'] = "Import Question";
            $this->load->library('csvimport');
            if (isset($_REQUEST["addcatg"])) {
                if ($_FILES["cat_img"]["size"] > 0) {
                    $config['upload_path'] = './uploads/';
                    $config['allowed_types'] = 'csv';
                    $config['encrypt_name'] = true;
                    $this->load->library('upload', $config);

                    if ($this->upload->do_upload('cat_img')) {
                        $img_data = $this->upload->data();

                        $file_path = './uploads/' . $img_data['file_name'];

                        if ($this->csvimport->get_array($file_path)) {
                            $csv_array = $this->csvimport->get_array($file_path);

                            foreach ($csv_array as $row) {
                                $csv_data[] = array(
                                    'question' => $row['question'],
                                    'answer' => $row['answer'],
                                    'categories' => explode(',', $row['categories']),
                                    'hints' => explode('~', $row['hints']),
                                    'notes' => explode('~', $row['notes']),
                                );
                            }
                        }

                        $this->question_model->importQuestions($csv_data);
                        $this->session->set_flashdata("success_req", '<div class="alert alert-success alert-dismissible" role="alert">
                                        <i class="fa fa-check"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Success!</strong> Question added successfully...
                                    </div>');
                        redirect('adminpanel/questions');
                    } else {
                        $data["error"] = '<div class="alert alert-error alert-dismissible" role="alert">
                                        <i class="fa fa-warning"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Warning!</strong> ' . $this->upload->display_errors() . '
                                    </div>';

                    }

                } else {
                    $data["error"] = '<div class="alert alert-error alert-dismissible" role="alert">
                                        <i class="fa fa-warning"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Warning!</strong> Upload CSV File
                                    </div>';
                }
            }

            $this->load->view('admin/importquestions', $data);
        } else {
            redirect('adminpanel');
        }
    }

    public function questions()
    {
        $this->data['page_title'] = "Questions";
        $questions = $this->question_model->getQuestions();
        if ($questions['status']) {
            $this->data['questions'] = $questions['questions'];
        } else {
            $this->data['questions'] = array();
        }
        $this->load->view('admin/questions', $this->data);

    }

    public function reports()
    {
        $this->data['page_title'] = "Reports";
        $reports = $this->question_model->getUserNotes();
        if ($reports['status']) {
            $this->data['reports'] = $reports['user_notes'];
        } else {
            $this->data['reports'] = array();
        }
        $this->load->view('admin/reports', $this->data);

    }

    public function massdeletequestions()
    {

        $question_ids = explode(',', $this->input->post('question_ids'));

        if (is_array($question_ids)) {

            if ($this->question_model->mass_delete_questions($question_ids)) {
                $this->session->set_flashdata("success_req", '<div class="alert alert-success alert-dismissible" role="alert">
                                        <i class="fa fa-check"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Success!</strong> Question(s) deleted successfully...
                                    </div>');
                redirect('adminpanel/questions');
            } else {
                $this->session->set_flashdata("success_req", '<div class="alert alert-danger alert-dismissible" role="alert">
                                        <i class="fa fa-check"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Failed!</strong> Question(s) cannot be deleted...
                                    </div>');
                redirect('adminpanel/questions');
            }
        } else {
            $this->session->set_flashdata("success_req", '<div class="alert alert-danger alert-dismissible" role="alert">
                                        <i class="fa fa-check"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Failed!</strong> Question(s) cannot be deleted...Nothing selected
                                    </div>');
            redirect('adminpanel/questions');
        }

    }

    public function addupdate()
    {
        if ($this->session->is_log_in) {
            $data["error"] = "";
            $data["active"] = "addcat";
            $data['page_title'] = "Add Update";
            if (isset($_REQUEST["addcatg"])) {
                $this->load->library('form_validation');
                $this->form_validation->set_rules('description', 'Update Description', 'trim|required');

                if ($this->form_validation->run() == false) {
                    if ($this->form_validation->error_string() != "") {
                        $data["error"] = '<div class="alert alert-error alert-dismissible" role="alert">
                                        <i class="fa fa-warning"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Warning!</strong> ' . $this->form_validation->error_string() . '
                                    </div>';
                    }
                } else {
                    $addcat = array(
                        "title" => $this->input->post("title"),
                        "description" => $this->input->post("description"),
                    );
                    $this->question_model->addupdate($addcat);
                    $this->session->set_flashdata("success_req", '<div class="alert alert-success alert-dismissible" role="alert">
                                        <i class="fa fa-check"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Success!</strong> Update added successfully...
                                    </div>');
                    redirect('adminpanel/updates');
                }
            }
            $this->load->view('admin/addupdate', $data);
        } else {
            redirect('adminpanel');
        }
    }

    public function updates()
    {
        $this->data['page_title'] = "Updates";
        $updates = $this->question_model->getUpdates();
        if ($updates['status']) {
            $this->data['updates'] = $updates['updates'];
        } else {
            $this->data['updates'] = array();
        }
        $this->load->view('admin/updates', $this->data);

    }

    public function deleteupdate($id)
    {
        if ($this->question_model->deleteupdate($id)) {
            $this->session->set_flashdata("success_req", '<div class="alert alert-success alert-dismissible" role="alert">
                                        <i class="fa fa-check"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Success!</strong> Update deleted successfully...
                                    </div>');
            redirect('adminpanel/updates');
        } else {
            $this->session->set_flashdata("success_req", '<div class="alert alert-danger alert-dismissible" role="alert">
                                        <i class="fa fa-check"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Failed!</strong> Update cannot be deleted...
                                    </div>');
            redirect('adminpanel/updates');
        }

    }

    public function updateaboutpage()
    {
        if ($this->session->is_log_in) {

            $id = 1; //static about data

            $data["error"] = "";
            $data["about"] = $this->category_model->getAbout($id);
            $data['page_title'] = "Edit About Page";

            if (isset($_REQUEST["savecat"])) {
                $this->load->library('form_validation');
                $this->form_validation->set_rules('about', 'About', 'trim|required|xss_clean');

                if ($this->form_validation->run() == false) {
                    if ($this->form_validation->error_string() != "") {
                        $data["error"] = '<div class="alert alert-error alert-dismissible" role="alert">
                                        <i class="fa fa-warning"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Warning!</strong> ' . $this->form_validation->error_string() . '
                                    </div>';
                    }
                } else {
                    $editcat = array(
                        "about" => $this->input->post("about"),
                    );

                    if ($this->category_model->updateaboutpage($id, $editcat)) {
                        $this->session->set_flashdata("success_req", '<div class="alert alert-success alert-dismissible" role="alert">
                                        <i class="fa fa-check"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Success!</strong> About updated successfully...
                                    </div>');
                        redirect('adminpanel/updateaboutpage');
                    } else {
                        $this->session->set_flashdata("error_req", '<div class="alert alert-danger alert-dismissible" role="alert">
                                        <i class="fa fa-check"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Failed!</strong> Failed to update About..
                                    </div>');
                        redirect('adminpanel/updateaboutpage');
                    }

                }
            }
            $this->load->view('admin/updateaboutpage', $data);
        } else {
            redirect('adminpanel');
        }
    }

    public function messages()
    {
        if ($this->session->is_log_in) {

            $alladminmessages = $this->user_model->getalladminmessages();
            $this->load->view("admin/alladminmessages", array("page_title" => 'Messages', "messages" => $alladminmessages));
        }}

    public function view_messages($user_id)
    {
        if ($this->session->is_log_in) {

            $alladminmessages = $this->user_model->getalladminmessages($user_id);
            $this->load->view("admin/adminchat", array("page_title" => 'Messages Convo', "messages" => $alladminmessages));
        }}

    public function addadminmessage()
    {

        if ($this->session->is_log_in) {

            if (isset($_POST)) {
                $user_id = $this->input->post('user_id');
                $this->load->library('form_validation');

                $this->form_validation->set_rules('user_id', 'User ID', 'trim|required');
                $this->form_validation->set_rules('admin_message', 'Admin message', 'trim|required');
                if ($this->form_validation->run() == false) {
                    if ($this->form_validation->error_string() != "") {
                        $this->session->set_flashdata("message", '<div class="alert alert-warning alert-dismissible" role="alert">
                                        <i class="fa fa-warning"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Warning!</strong> ' . $this->form_validation->error_string() . '
                                    </div>');
                    }

                } else {

                    $user_id = $this->input->post('user_id');
                    $message = $this->input->post('admin_message');

                    if ($this->user_model->messageadmin($user_id, $message, true)) {
                        $this->session->set_flashdata("message", '<div class="alert alert-success alert-dismissible" role="alert">
                                        <i class="fa fa-check"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Success!</strong> Your message sent successfully...
                                    </div>');
                    } else {
                        $this->session->set_flashdata("message", '<div class="alert alert-warning alert-dismissible" role="alert">
                                        <i class="fa fa-warning"></i>
                                      <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                                      <strong>Error!Unable to send message</strong>
                                    </div>');
                    }

                    redirect("adminpanel/messages");
                }

                $alladminmessages = $this->user_model->getalladminmessages($user_id);
                $this->load->view("admin/adminchat", array("messages" => $alladminmessages));
            }} else {
            redirect('login');
        }
    }

    public function logout()
    {
        session_destroy();
        redirect('adminpanel');
    }

}
