<?php defined('BASEPATH') || exit('No direct script access allowed');

class Products_model extends CI_Model
{

    public function __construct()
    {
        parent::__construct();
    }

    public function getProducts($id = '',$name = '',$userid = '',$stock_status = ''){
        $return_array = array();

        $this->db->select("products.id,products.name,products.description,products.price,products.image,products.status,products.url,
            CASE WHEN products.status = 0 
            THEN 'Out Of Stock'
             ELSE 'In Stock'  END AS product_status")
            ->from('products')->order_by('updated_at','desc');

        if($id != ''){
            $this->db->where('products.id',$id);
        }
        if($name != ''){
            $this->db->where('products.name',$name);
        } 

        if($stock_status != ''){

            $status = ($stock_status == 'in_stock') ? 1 : 0;

            $this->db->where('products.status',$status);
        }
        $query_results = $this->db->get()->result_array();

        if(count($query_results) > 0){
            $return_array['status'] = true;
            foreach($query_results as $query_result){
                $query_result['image'] = ($query_result['image'] != '') ? base_url().'uploads/'.$query_result['image'] : '';
                $return_array['products'][] = $query_result;
            }
        }else{
            $return_array['status'] = false;
            $return_array['message'] = 'No Products(s) were found';
        }
        return $return_array;

    }

    public function add_product($addcat)
    {
        if($this->db->insert("products",$addcat)){
            return true;
        }
        return false;
    }

    public function edit_product($id,$editcat)
    {
        if($this->db->update("products",$editcat,array("id"=>$id))){
            return true;
        }
        return false;
    }

    function delete_product($id){
        return $this->db->where('id',$id)->delete('products');
    }

    public function getProductUpdates($user_id = '',$id = ''){
        $return_array = array();

        if($user_id != ''){
            $query_str = "SELECT a.id as update_id from products as a where a.status = 1 and a.id NOT IN (SELECT product_id from product_reads where user_id = '".$user_id."' )   ";

        }else{
            $query_str = "SELECT a.id as id from products as a where a.status = 1 "; 
        }
        
        if($id != ''){
            $query_str.=" and a.id = '".$id."'";
        }
        
        $query_results = $this->db->query($query_str)->result_array();

        if(count($query_results) > 0){
            $return_array['status'] = true;
            foreach($query_results as $query_result){
                $return_array['updates'][] = $query_result;
            }
        }else{
            $return_array['status'] = false;
            $return_array['message'] = 'No Update(s) were found';
        }
        return $return_array;

    }

    public function setupdateread($addcat){

        $count = 0;

        $q = $this->db->query("SELECT id as product_id from products where id NOT IN(SELECT product_id from product_reads where user_id = '".$addcat['user_id']."')");

        $num_updates = $q->num_rows();


        if($num_updates > 0){
            foreach ($q->result_array() as $update) {
                $data = array(
                    'product_id' => $update['product_id'],
                    'user_id' => $addcat['user_id'],
                );
                if($this->db->insert("product_reads",$data)){
                    $count++;
                }
            }
        }

        if($count == $num_updates){
            return true;
        }
        
        return false;
    }

    function getAbout($id){
        return $this->db->where('id',$id)->get('about_page')->row();
    }

     public function updateaboutpage($id,$editcat)
    {
        if($this->db->update("about_page",$editcat,array("id"=>$id))){
            return true;
        }
        return false;
    }



}