<?php defined('BASEPATH') || exit('No direct script access allowed');

class Question_model extends CI_Model
{

    public function __construct()
    {
        parent::__construct();
    }

    public function getQuestions($category_id = '',$limit = '',$question_id = '',$question_state = '',$update_available = false){
        $return_array = array();


        $query_str = '';
        if($category_id != '') {
            $query_str = "select a.id as question_id,a.question as question,a.answer as answer,group_concat(distinct(b.category_id) SEPARATOR '~') as category_id,c.name as category_name ,group_concat(distinct(d.hint) SEPARATOR '~') as hints,group_concat(distinct(e.note)) as notes,
    CASE WHEN COUNT(distinct(d.hint)) > 0
             THEN COUNT(distinct(d.hint))
         ELSE 0
    END AS hints_count,CASE WHEN COUNT(distinct(e.note)) > 0
             THEN COUNT(distinct(e.note))
         ELSE 0
    END AS notes_count from questions as a join question_categories as b on a.id = b.question_id join categories as c on b.category_id=c.id left join question_hints as d on a.id=d.question_id left join question_notes as e on a.id=e.question_id left join question_states as qst on a.id = qst.question_id ";
            if( strpos($category_id, ',') !== false ) {
                $query_str .= " where b.category_id IN(" . $category_id . ")";
            }else{
                $query_str .= " where b.category_id ='" . $category_id . "'";
            }


        }else{
            $query_str = "select a.id as question_id,a.question as question,a.answer as answer,group_concat(distinct(b.category_id)) as category_id,group_concat(distinct(c.name)) as category_name,group_concat(distinct(d.hint) SEPARATOR '~') as hints,group_concat(distinct(e.note) SEPARATOR '~') as notes,
    CASE WHEN COUNT(distinct(d.hint)) > 0
             THEN COUNT(distinct(d.hint))
         ELSE 0
    END AS hints_count,CASE WHEN COUNT(distinct(e.note)) > 0
             THEN COUNT(distinct(e.note))
         ELSE 0
    END AS notes_count  from questions as a join question_categories as b on a.id = b.question_id join categories as c on b.category_id=c.id left join question_hints as d on a.id=d.question_id left join question_notes as e on a.id=e.question_id left join question_states as qst on a.id = qst.question_id";
        }

        if($question_id != ''){
            $query_str.=" where a.id ='".$question_id."'";

            if($question_state != ''){
                $query_str.=" and qst.question_state ='".$question_state."'";
            }

            if($update_available){
                $query_str.=" and a.user_update_flag = 1";
            }

        }else{
            if($question_state != ''){
                $query_str.=" where qst.question_state ='".$question_state."'";

                if($update_available){
                $query_str.=" and a.user_update_flag = 1";
            }
            }else{
                if($update_available){
                $query_str.=" where a.user_update_flag = 1";
            }

            }
        }



        $query_str.=' GROUP BY a.id ORDER BY a.id desc';


        if($limit != ''){
            $query_str.=' LIMIT 0,'.$limit;
        }

        $query_results = $this->db->query($query_str)->result_array();


        if(count($query_results) > 0){
            $return_array['status'] = true;
            foreach($query_results as $query_result){
                $return_array['questions'][] = $query_result;
            }
        }else{
            $return_array['status'] = false;
            $return_array['message'] = 'No questions(s) were found';
        }
        return $return_array;

    }

    public function postQuestionNotes($question_notes){
        $return_array = array();
        if($this->db->insert('question_user_notes',$question_notes)){
            $return_array['status'] = true;
            $return_array['response']['message'] = 'Question Notes Posted Successfully';
            $return_array['response']['question_note_id'] = $this->db->insert_id();
        }else{
            $return_array['status'] = false;
            $return_array['message'] = 'Error..Unable to post question notes';
        }

        return $return_array;

    }

    public function postQuestionWiseNotes($question_notes){
        $return_array = array();
        if($this->db->insert('question_notes',$question_notes)){
            $return_array['response']['question_note_id'] = $this->db->insert_id();
            if(isset($question_notes['privacy']) &&  $question_notes['privacy'] == 'public'){
                $this->updateUserUpdateFlagByQuestion($question_notes['question_id']);
            }
            $return_array['status'] = true;
            $return_array['response']['message'] = 'Question Notes Posted Successfully';
            
        }else{
            $return_array['status'] = false;
            $return_array['message'] = 'Error..Unable to post question notes';
        }

        return $return_array;

    }

    public function setQuestionState($question_notes){
        $return_array = array();
        if($this->checkQuestionState($question_notes['question_id'],$question_notes['user_id'])){
            $this->db->where('question_id',$question_notes['question_id'])->where('user_id',$question_notes['user_id'])->delete('question_states');
        }

        if( strpos($question_notes['question_state'], ',') !== false ) {

            $question_states = explode(',',$question_notes['question_state']);

            foreach ($question_states as $state) {
                $question_note_data = array(
                'question_id' => $question_notes['question_id'],
                'user_id' => $question_notes['user_id'],
                'question_state' => $state
                );
                $this->db->insert('question_states',$question_note_data);
            }
            $return_array['status'] = true;
            $return_array['response']['message'] = 'Question State(s) Updated Successfully';

            }else{
               if($this->db->insert('question_states',$question_notes)){
            $return_array['status'] = true;
            $return_array['response']['message'] = 'Question State Updated Successfully';
        }else{
            $return_array['status'] = false;
            $return_array['message'] = 'Error..Unable to post question notes';
        }
            }

    

        return $return_array;

    }

    function checkQuestionState($question_id,$user_id){
        $q = $this->db->select("id")
        ->from('question_states')
        ->where('question_id',$question_id)->where('user_id',$user_id)->get();

        if($q->num_rows() > 0){
            return true;
        }
        return false;
    }

    public function add_question()
    {

        $addcat = array(
            "question"=>$this->input->post("question"),
            "answer"=>$this->input->post("answer"),
            "user_update_flag"=>1,
        );

        if($this->db->insert("questions",$addcat)){
            $question_id = $this->db->insert_id();
            foreach ($this->input->post('category') as $cat){
                $q_cat = array(
                    'category_id' => $cat,
                    'question_id' => $question_id
                );
                $this->db->insert('question_categories',$q_cat);
            }

            $hints = explode('~',$this->input->post('hints'));
            $notes = explode('~',$this->input->post('notes'));

            if(count($hints) > 0){

                foreach ($hints as $hint){
                    if($hint != ''){
                        $hint_insert_data = array(
                            'hint' => $hint,
                            'question_id' => $question_id
                        );
                        $this->db->insert('question_hints',$hint_insert_data);
                    }

                }
            }
            if(count($notes) > 0){

                foreach ($notes as $note){
                    if($note != ''){
                        $hint_insert_data = array(
                            'note' => $note,
                            'question_id' => $question_id
                        );
                        $this->db->insert('question_notes',$hint_insert_data);
                    }

                }
            }

        }
        return true;
    }

    public function edit_question($id)
    {

        $editcat = array(
            "question"=>$this->input->post("question"),
            "answer"=>$this->input->post("answer"),
             "user_update_flag"=>1,
        );

        if($this->db->update("questions",$editcat,array("id"=>$id))){
            if($this->db->delete('question_categories', array('question_id' => $id))) {
                foreach ($this->input->post('category') as $cat) {
                    $q_cat = array(
                        'category_id' => $cat,
                        'question_id' => $id
                    );
                    $this->db->insert('question_categories', $q_cat);
                }
            }
            $hints = explode('~',$this->input->post('hints'));
            $notes = explode('~',$this->input->post('notes'));

            if(count($hints) > 0){
                $this->db->delete('question_hints', array('question_id' => $id));
                foreach ($hints as $hint){
                    if($hint != ''){
                        $hint_insert_data = array(
                            'hint' => $hint,
                            'question_id' => $id
                        );
                        $this->db->insert('question_hints',$hint_insert_data);
                    }

                }
            }
            if(count($notes) > 0){
                $this->db->delete('question_notes', array('question_id' => $id));

                foreach ($notes as $note){
                    if($note != ''){
                        $hint_insert_data = array(
                            'note' => $note,
                            'question_id' => $id
                        );
                        $this->db->insert('question_notes',$hint_insert_data);
                    }

                }
            }

        }
        return true;
    }

    function delete_question($id){
        if($this->db->delete('question_categories', array('question_id' => $id))
            && $this->db->delete('question_hints', array('question_id' => $id))
            && $this->db->delete('question_notes', array('question_id' => $id))
            && $this->db->delete('question_user_notes', array('question_id' => $id))
        ){
            return $this->db->where('id',$id)->delete('questions');
        }
        return false;
    }

    function mass_delete_questions($ids){

        $count = 0;

        if(is_array($ids) && count($ids) > 0){
            foreach ($ids as $id) {
            if($this->db->delete('question_categories', array('question_id' => $id))
            && $this->db->delete('question_hints', array('question_id' => $id))
            && $this->db->delete('question_notes', array('question_id' => $id))
            && $this->db->delete('question_user_notes', array('question_id' => $id))
        ){
            if($this->db->where('id',$id)->delete('questions')){
                $count++;
            }
        }
        }
        }

        

        if($count > 0){
            return true;
        }
        return false;

        
    }

    function deletequestionreport($id){
        if($this->db->delete('question_user_notes', array('id' => $id))){
            return true;
        }
        return false;
    }

    function importQuestions($data){

        foreach ($data as $datum){
            $question_data = array(
                "question"=>$datum["question"],
                "answer"=>$datum["answer"],
                 "user_update_flag"=>1,
            );
            if($this->db->insert("questions",$question_data)){
                $question_id = $this->db->insert_id();

                foreach ($datum['categories'] as $cat){
                    if($cat != ''){
                        $cat_check = $this->category_model->getCategories('',trim($cat));
                        if($cat_check['status']){
                            $cat_data = $cat_check['categories'][0];
                            $cat_insert_data = array(
                                'category_id' => $cat_data['id'],
                                'question_id' => $question_id
                            );
                            $this->db->insert('question_categories',$cat_insert_data);

                        }else{
                            $q_cat = array(
                                'name' => $cat,
                            );
                            $this->db->insert('categories',$q_cat);
                            $cat_id = $this->db->insert_id();
                            $cat_insert_data = array(
                                'category_id' => $cat_id,
                                'question_id' => $question_id
                            );
                            $this->db->insert('question_categories',$cat_insert_data);

                        }

                    }


                }
                foreach ($datum['hints'] as $hint){
                    if($hint != ''){
                        $hint_insert_data = array(
                            'hint' => $hint,
                            'question_id' => $question_id
                        );
                        $this->db->insert('question_hints',$hint_insert_data);
                    }

                }

                foreach ($datum['notes'] as $note){
                    if($note != ''){
                        $hint_insert_data = array(
                            'note' => $note,
                            'question_id' => $question_id
                        );
                        $this->db->insert('question_notes',$hint_insert_data);
                    }

                }

            }

        }
        return true;
    }

    function getUserNotes($notetype = 'report',$question_id = '',$user_id = ''){
        $return_array = array();

        $this->db->select('question_user_notes.id as note_id,question_user_notes.question_id as question_id,questions.question,question_user_notes.user_id as user_id,users.name as name,users.email as email,question_user_notes.note,question_user_notes.note_type,question_user_notes.created_at,question_user_notes.resolved_flag')
            ->from('question_user_notes')
            ->join('users','users.id = question_user_notes.user_id','left')
            ->join('questions','questions.id = question_user_notes.question_id','left')
            ->group_by('question_user_notes.id');
        if($notetype != ''){
            $this->db->where('question_user_notes.note_type',$notetype);
        }if($question_id != ''){
            $this->db->where('question_user_notes.question_id',$question_id);
        }
        if($user_id != ''){
            $this->db->where('question_user_notes.user_id',$user_id);
        }

        $q = $this->db->get();
        if($q->num_rows() > 0){
            $return_array['status'] = true;
            $return_array['user_notes'] = $q->result_array();
        }else{
            $return_array['status'] = false;
            $return_array['user_notes'] = NULL;

        }
        return $return_array;
    }

    function getQuestionNotes($question_id){
        $return_array = array();

        $this->db->select('question_notes.id as notes_id,question_notes.question_id,question_notes.note,question_notes.privacy')
            ->from('question_notes')->where('question_notes.question_id',$question_id);
        

        $q = $this->db->get();
        if($q->num_rows() > 0){
            $return_array['status'] = true;
            $return_array['user_notes'] = $q->result_array();
        }else{
            $return_array['status'] = false;
            $return_array['user_notes'] = NULL;

        }
        return $return_array;
    }

    function getCounts($cat_id  = ''){
        $return_array = array();

        $this->db->select('count(questions.id) as total_questions')
            ->from('questions');


        if($cat_id != ''){
            $this->db->join('question_categories','questions.id = question_categories.question_id','left');
            $this->db->select('question_categories.category_id');
            $this->db->where('question_categories.category_id',$cat_id);
            $this->db->group_by('question_categories.category_id');
        }


        $q = $this->db->get();

        $this->db->select('count(id) as total_categories')
            ->from('categories');

        $c = $this->db->get();


        if($q->num_rows() > 0){
            $return_array['status'] = true;
            $return_array['counts']['questions'] = $q->row();
            $return_array['counts']['categories'] = $c->row();
        }else{
            $return_array['status'] = false;
            $return_array['counts'] = NULL;

        }
        return $return_array;
    }

    function getQuestionStates($where){

        if($where['question_state'] == 'unanswered'){
             $query_str = "select a.id as question_id,a.question as question,a.answer as answer,group_concat(distinct(b.category_id)) as category_id,group_concat(distinct(c.name)) as category_name,group_concat(distinct(d.hint)) as hints,group_concat(distinct(e.note)) as notes,'".$where['user_id']."' as user_id,'unanswered' as question_state, CASE WHEN COUNT(distinct(d.hint)) > 0
             THEN COUNT(distinct(d.hint))
         ELSE 0
    END AS hints_count,CASE WHEN COUNT(distinct(e.note)) > 0
             THEN COUNT(distinct(e.note))
         ELSE 0
    END AS notes_count from questions as a left join question_categories as b on a.id = b.question_id join categories as c on b.category_id=c.id left join question_hints as d on a.id=d.question_id left join question_notes as e on a.id=e.question_id where a.id NOT IN(select question_id from question_states where user_id = '".$where['user_id']."' and question_state != 'unanswered' )";

        }else{
            $query_str = "select a.id as question_id,a.question as question,a.answer as answer,group_concat(distinct(b.category_id)) as category_id,group_concat(distinct(c.name)) as category_name,group_concat(distinct(d.hint)) as hints,group_concat(distinct(e.note)) as notes,qs.user_id as user_id,group_concat(distinct(qs.question_state)) as question_state, CASE WHEN COUNT(distinct(d.hint)) > 0
             THEN COUNT(distinct(d.hint))
         ELSE 0
    END AS hints_count,CASE WHEN COUNT(distinct(e.note)) > 0
             THEN COUNT(distinct(e.note))
         ELSE 0
    END AS notes_count from questions as a join question_states as qs on a.id = qs.question_id join question_categories as b on a.id = b.question_id join categories as c on b.category_id=c.id left join question_hints as d on a.id=d.question_id left join question_notes as e on a.id=e.question_id";

         if($where['user_id'] != ''){
            $query_str.=" where qs.user_id ='".$where['user_id']."'";
        }
        if($where['question_state'] != ''){
                $query_str .=" and qs.question_state ='".$where['question_state']."'";    
            }
        }

         

        if($where['category_id'] != ''){

        if( strpos($where['category_id'], ',') !== false ) {
                $query_str .= " and b.category_id IN(" . $where['category_id'] . ")";
            }else{
                $query_str .= " and b.category_id ='" . $where['category_id'] . "'";
            }
        }


        $query_str.=' GROUP BY a.id ORDER BY a.id desc';


        
        $query_results = $this->db->query($query_str)->result_array();


        if(count($query_results) > 0){
            $return_array['status'] = true;
            foreach($query_results as $query_result){
                $return_array['questions'][] = $query_result;
            }
        }else{
            $return_array['status'] = false;
            $return_array['message'] = 'No questions(s) were found';
        }
        return $return_array;

        
    }

    function getQuestionStatesCount($where){

        if($where['question_state'] == 'unanswered'){

         $query_str = "select count(distinct(a.id)) as no_of_questions,'".$where['user_id']."' as user_id,'unanswered' as question_state from questions as a left join question_categories as b on a.id = b.question_id left join categories as c on b.category_id=c.id where a.id NOT IN(select question_id from question_states where user_id = '".$where['user_id']."' and question_state != 'unanswered' ) ";
        }else{
            $query_str = "select count(distinct(qs.question_id)) as no_of_questions,qs.user_id as user_id,qs.question_state as question_state from questions as a right join question_states as qs on a.id = qs.question_id left join question_categories as b on a.id = b.question_id left join categories as c on b.category_id=c.id";

         if($where['user_id'] != ''){
            $query_str.=" where qs.user_id ='".$where['user_id']."'";
        }
        if($where['question_state'] != ''){
                $query_str .=" and qs.question_state ='".$where['question_state']."'";
            }
        }

        if($where['category_id'] != ''){

        if( strpos($where['category_id'], ',') !== false ) {
                $query_str .= " and b.category_id IN(" . $where['category_id'] . ")";
            }else{
                $query_str .= " and b.category_id ='" . $where['category_id'] . "'";
            }
        }


        $query_str.=' ';



        $query_results = $this->db->query($query_str)->result_array();


        if(count($query_results) > 0){
            $return_array['status'] = true;
            foreach($query_results as $query_result){
                $return_array['questions'][] = $query_result;
            }
        }else{
            $return_array['status'] = false;
            $return_array['message'] = 'No questions(s) were found';
        }
        return $return_array;

        
    }

    function updateUserUpdateFlagByQuestion($question_id){
        if($this->db->update('questions',array('user_update_flag' => 1),array('id'=>$question_id))){
            return true;
        }
        return false;
    }


     public function addupdate($addcat)
    {
        if($this->db->insert("update_log",$addcat)){
            return true;
        }
        return false;
    }

    public function getUpdates($user_id = '',$id = ''){
        $return_array = array();

        if($user_id != ''){
            $query_str = "SELECT a.id as update_id,a.title,a.description,a.created_at from update_log as a where a.id NOT IN (SELECT update_log_id from update_log_reads where user_id = '".$user_id."' )   ";

        }else{
            $query_str = "SELECT a.id as id,a.title,a.description,a.created_at from update_log as a"; 
        }
        
        if($id != ''){
            $query_str.=" and a.id = '".$id."'";
        }
        
        $query_results = $this->db->query($query_str)->result_array();

        if(count($query_results) > 0){
            $return_array['status'] = true;
            foreach($query_results as $query_result){
                $return_array['updates'][] = $query_result;
            }
        }else{
            $return_array['status'] = false;
            $return_array['message'] = 'No Update(s) were found';
        }
        return $return_array;

    }

    public function setupdateread($addcat){

        $count = 0;

        $q = $this->db->query("SELECT id as update_id from update_log where id NOT IN(SELECT update_log_id from update_log_reads where user_id = '".$addcat['user_id']."')");

        $num_updates = $q->num_rows();


        if($num_updates > 0){
            foreach ($q->result_array() as $update) {
                $data = array(
                    'update_log_id' => $update['update_id'],
                    'user_id' => $addcat['user_id'],
                );
                if($this->db->insert("update_log_reads",$data)){
                    $count++;
                }
            }
        }

        if($count == $num_updates){
            return true;
        }
        
        return false;
    }

    function deleteupdate($id){
        if($this->db->delete('update_log', array('id' => $id))){
            return true;
        }
        return false;
    }




}