<?php defined('BASEPATH') || exit('No direct script access allowed');

class User_model extends CI_Model{

    public function __construct() {
        parent::__construct();
    }

    public function validateAdminLogin($post){
        $user = $this->db->where('email',$post['email'])->get('users')->row();

        if(count($user) > 0){
            if(password_verify($post['password'], $user->password)){
                if($user->role != 'ADMIN'){
                    $this->session->set_flashdata('error_message','Error ! Not an Admin User');
                    redirect('adminpanel/login');
                }else{
                    $this->session->set_userdata('is_log_in',true);
                    $this->session->set_userdata('email',$user->email);
                    $this->session->set_userdata('role',$user->role);
                    redirect('adminpanel');
                }

            }else{
                $this->session->set_flashdata('error_message','Invalid User/Password');
                redirect('adminpanel/login');
            }
        }else{
            $this->session->set_flashdata('error_message','Invalid User/Password');
            redirect('adminpanel/login');
        }
    }


    public function validateUserLogin($post){
        $return_array = array();

        $user = $this->db->where('email',$post['email'])->get('users')->row();

        if(count($user) > 0){
            if(password_verify($post['password'], $user->password)){
                if($user->role != 'USER'){
                    $return_array['status'] = false;
                    $return_array['message'] = 'Error ! Not an User';
                }
                else{
                    if($user->status != '1'){
                        $return_array['status'] = false;
                        $return_array['message'] = 'Error ! Inactive / Blocked User';
                    }else{

                        $return_array['status'] = true;
                        $return_array['user_login']['message'] = 'Successfully logged in';
                        $return_array['user_login']['user_id'] = $user->id;

                    }


                }

            }else{
                $return_array['status'] = false;
                $return_array['message'] = 'Invalid User/Password';;
            }
        }else{
            $return_array['status'] = false;
            $return_array['message'] = 'Invalid User/Password';
        }
        return $return_array;
    }


    public function createUser($insert_data){
        $return_array = array();

        if($this->db->insert('users',$insert_data)){
            $email_data['to_address']      = array($insert_data['email']); // Send email to our user
            $email_data['subject'] = 'FlashCard Signup'; // Give the email a subject
            $email_data['html'] = '
            
Thanks for signing up!
Your account has been created.
 
------------------------
Username: '.$insert_data['email'].'

------------------------ 
';
            /* Verification Code: '.$insert_data['verify_code'].'*/
            emailSender($email_data);

            $return_array['status'] = true;
            $return_array['message'] = 'Successfully User Registered.Check Mail';
            $return_array['id'] = $this->db->insert_id();
        }else{
            $return_array['status'] = false;
            $return_array['message'] = 'DB Error..Unable to register user';
        }

        return $return_array;

    }

    public function findUserBy($where_cond,$where){
        return $this->db->where($where_cond,$where)->get('users')->row();
    }

    public function updateUserData($update_data,$user_id){
        if($this->db->update('users',$update_data,array('id' => $user_id))){
            $return_array['status'] = true;
            $return_array['message'] = 'Successfully User Profile Updated.';
        }else{
            $return_array['status'] = false;
            $return_array['message'] = 'DB Error..Unable to update user profile';
        }
        return $return_array;
    }

    public function postUserResult($userid, $result_data, $decoded_data){

        $counter = 0 ;
        $return_array = array();


       foreach ($decoded_data as $key => $cat) {
           $insert_data = array(
               'user_id' => $userid,
               'result_data' => $result_data,
               'category_id' => $key,
               'question_count' => $cat['question_count'],
               'correct_count' => $cat['correct_count'],
               'incorrect_count' => $cat['incorrect_count'],
               'skip_count' => $cat['skip_count'],
               'bookmark_count' => $cat['bookmark_count'],
           );
           if ($this->db->insert('user_result', $insert_data)) {
              $counter++;
           }
       }
       if($counter == count($decoded_data)){
           $return_array['status'] = true;
           $return_array['message'] = "Successfully User Data set";
       }else{
           $return_array['status'] = false;
           $return_array['message'] = "failed to set user data";
       }
        return $return_array;

    }

    public function getUserStatistics($user_id){
        $return_array = array();

        $query_str = "select sum(question_count) as total_question_count,sum(correct_count) as total_correct_count,sum(incorrect_count) as total_incorrect_count,sum(skip_count) as skip_count,sum(bookmark_count) as bookmark_count from user_result WHERE user_id ='" . $user_id ."'";

        $query_results = $this->db->query($query_str)->result_array();

        $cat_query_str = "select b.name,sum(question_count) as total_question_count,sum(correct_count) as total_correct_count,sum(incorrect_count) as total_incorrect_count,sum(skip_count) as skip_count,sum(bookmark_count) as bookmark_count,category_id as category from user_result as a left join categories as b on a.category_id=b.id WHERE user_id ='" . $user_id ."' group by category_id";

        $cat_query_results = $this->db->query($cat_query_str)->result_array();

        if(count($query_results) > 0){
            $return_array['status'] = true;
            $return_array['response']['statistics'] = $query_results;
            $return_array['response']['category_statistics'] = $cat_query_results;

        }else{
            $return_array['status'] = false;
            $return_array['message'] = 'No stats were found';
        }
        return $return_array;

    }


    public function clearUserStats($user_id){

        $return_array = array(
            'status' => false
        );

        if($user_id != ''){
            if($this->checkUserStatsById($user_id)){
              if($this->db->where('user_id',$user_id)->delete('user_result') && $this->db->where('user_id',$user_id)->delete('question_states')){
                $return_array['status'] = true;
                $return_array['message'] = 'Successfully user stats cleared';
            }else{
                 $return_array['status'] = false;
                $return_array['message'] = 'Failed to clear user stats';
            }  
        }else{
            $return_array['status'] = false;
                $return_array['message'] = 'No user stats for the given user ID '.$user_id;
        }
    }else{
            $return_array['status'] = false;
                $return_array['message'] = 'empty userID';
        }
        return $return_array;
    }
public function getUpdateAvailable($user_id){

        $return_array = array(
            'status' => false
        );

        if($user_id != ''){

            $query = "SELECT count(a.id) as question_count from questions as a  where a.user_update_flag = '1'"; 

            $resultq = $this->db->query($query);

            if($resultq->num_rows() > 0){
                        $return_array['status'] = true;
                        $return_array['data'] = $resultq->result_array();
                    }else{
                        $return_array['status'] = false;
                        $return_array['message'] = 'Failed to get question(s)';
                    } 
        }else{
            $return_array['status'] = false;
                $return_array['message'] = 'empty userID';
        }
        return $return_array;
    }

     public function setupdateddone(){
 ;

        $return_array = array();

        $query_str = "UPDATE questions SET user_update_flag = '0' where 1";

        if($this->db->query($query_str)){
            $return_array['status'] = true;
            $return_array['message'] = 'Update Status posted Successfully';
        }else{
            $return_array['status'] = false;
            $return_array['message'] = 'Error..Unable to post question notes';
        }

        return $return_array;

    }

    private function checkUserStatsById($user_id){
        $q = $this->db->where('user_id',$user_id)->get('user_result');

        if($q->num_rows() > 0){
            return true;
        }
        return false;
    }

    public function messageadmin($user_id,$message,$admin_message = 'false'){
        $type = ($admin_message == 'true') ? 'admin' : 'user';

        $data = array(
            'user_id' => $user_id,
            'message' => $message,
            'type' => $type
        );

        if($this->db->insert('chats',$data)){
            return true;
        }
        return false;
    } 

    public function getadminmessages($user_id){
        $q = $this->db->where('user_id',$user_id)->get('chats');
        return $q->result_array();

    }

    public function getalladminmessages($user_id = ''){

        $this->db->select('chats.*,users.name as user_name')->join('users','users.id = chats.user_id','left');

        if($user_id != ''){
            $this->db->where('chats.user_id',$user_id);
        }else{
            $this->db->group_by('chats.user_id');
        }

        $q = $this->db->get('chats');
        return $q->result();

    }




}